//#if net_2_0
//#pragma warning disable 1591, 162
//#endif
// created by jay 0.7 (c) 1998 Axel.Schreiner@informatik.uni-osnabrueck.de

					// line 1 "Parser.jay"

//
// Parser.jay: The Parser for MyJScript
//

using System;
using System.CodeDom;
using System.CodeDom.Compiler;
using System.Collections.Generic;


namespace MyJScript.Compiler
{
	/// <summary>
	///    The MyJScript Parser
	/// </summary>
	public class Parser : GenericParser {
		
		/// <summary>
		/// Return the errors encountered.
		/// </summary>
		public CompilerErrorCollection Errors
		{
			get
			{
				if ( report == null )
					return null;
				return report.Errors;
			}
		}		
		private Report report;
		
		/// <summary>
		/// Code generator
		/// </summary>
		private Generator generator;	

        /// <summary>
        /// Function arguments
        /// </summary>
        private List<String> arguments;
                		
		/// <summary>
		/// Result of generation
		/// </summary>
		public CodeNamespace Result
		{
			get { return generator.Result; }
		}

					// line 58 "-"

  /// <summary>
  /// simplified error message.
  /// </summary>
  /// <param name="state">state</param>
  /// <param name="token">token</param>
  /// <param name="tokenValue">tokenValue</param>
  /// <param name="expecting">expecting states</param>
  public void yyerror (int state, int token, object tokenValue, string[] expecting) {
    report.Error(lexer.Location, state, token, tokenValue, expecting); 
  }

  /// <summary>
  /// debugging support, requires the package jay.yydebug.
  /// Set to null to suppress debugging messages.
  /// </summary>
//t  protected yydebug.yyDebug debug;

  protected static  int yyFinal = 1;
//t  public static  string [] yyRule = {
//t    "$accept : program",
//t    "$$1 :",
//t    "program : $$1 opt_list_function_statement",
//t    "opt_list_function_statement : list_function_statement",
//t    "opt_list_function_statement :",
//t    "list_function_statement : list_function_statement function_or_statement",
//t    "list_function_statement : function_or_statement",
//t    "function_or_statement : function_decl",
//t    "function_or_statement : statement",
//t    "$$2 :",
//t    "$$3 :",
//t    "function_decl : FUNCTION IDENT $$2 LPAR opt_list_param RPAR $$3 block",
//t    "opt_list_param : list_param",
//t    "opt_list_param :",
//t    "list_param : list_param CM IDENT",
//t    "list_param : IDENT",
//t    "$$4 :",
//t    "block : LBRA $$4 opt_list_statement RBRA",
//t    "opt_list_statement : list_statement",
//t    "opt_list_statement :",
//t    "list_statement : list_statement statement",
//t    "list_statement : statement",
//t    "statement : decl_var",
//t    "statement : setvar",
//t    "statement : if_else",
//t    "statement : while",
//t    "statement : proc_call",
//t    "statement : return",
//t    "decl_var : VAR IDENT opt_init SC",
//t    "opt_init : EQ expr",
//t    "opt_init :",
//t    "setvar : IDENT EQ expr SC",
//t    "$$5 :",
//t    "if_else : IF LPAR cond_expr RPAR block_or_statement $$5 ELSE block_or_statement",
//t    "if_else : IF LPAR cond_expr RPAR block_or_statement",
//t    "$$6 :",
//t    "funct_call : IDENT LPAR $$6 opt_list_expr RPAR",
//t    "proc_call : funct_call SC",
//t    "while : WHILE LPAR cond_expr RPAR block_or_statement",
//t    "return : RETURN expr SC",
//t    "return : RETURN SC",
//t    "block_or_statement : block",
//t    "block_or_statement : statement",
//t    "cond_expr : expr EQEQ expr",
//t    "cond_expr : expr NE expr",
//t    "cond_expr : expr GT expr",
//t    "cond_expr : expr LS expr",
//t    "cond_expr : expr GTEQ expr",
//t    "cond_expr : expr LSEQ expr",
//t    "expr : expr PLUS expr",
//t    "expr : expr MULT expr",
//t    "expr : expr MINUS expr",
//t    "expr : expr DIV expr",
//t    "expr : funct_call",
//t    "expr : literal",
//t    "literal : NUMBER",
//t    "literal : STRING",
//t    "literal : IDENT",
//t    "opt_list_expr : list_expr",
//t    "opt_list_expr :",
//t    "list_expr : list_expr CM expr",
//t    "list_expr : expr",
//t  };
  protected static  string [] yyName = {    
    "end-of-file",null,null,null,null,null,null,null,null,null,null,null,
    null,null,null,null,null,null,null,null,null,null,null,null,null,null,
    null,null,null,null,null,null,null,null,null,null,null,null,null,null,
    null,null,null,null,null,null,null,null,null,null,null,null,null,null,
    null,null,null,null,null,null,null,null,null,null,null,null,null,null,
    null,null,null,null,null,null,null,null,null,null,null,null,null,null,
    null,null,null,null,null,null,null,null,null,null,null,null,null,null,
    null,null,null,null,null,null,null,null,null,null,null,null,null,null,
    null,null,null,null,null,null,null,null,null,null,null,null,null,null,
    null,null,null,null,null,null,null,null,null,null,null,null,null,null,
    null,null,null,null,null,null,null,null,null,null,null,null,null,null,
    null,null,null,null,null,null,null,null,null,null,null,null,null,null,
    null,null,null,null,null,null,null,null,null,null,null,null,null,null,
    null,null,null,null,null,null,null,null,null,null,null,null,null,null,
    null,null,null,null,null,null,null,null,null,null,null,null,null,null,
    null,null,null,null,null,null,null,null,null,null,null,null,null,null,
    null,null,null,null,null,null,null,null,null,null,null,null,null,null,
    null,null,null,null,null,null,null,null,null,null,null,null,null,null,
    null,null,null,null,null,null,null,"PLUS","MINUS","MULT","DIV","EQ",
    "EQEQ","NE","GT","LS","GTEQ","LSEQ","LPAR","RPAR","LBRA","RBRA","CM",
    "SC","NUMBER","STRING","IDENT","VAR","FUNCTION","IF","ELSE","WHILE",
    "RETURN","ERROR",
  };

//t  public static string yyname (int token) {
//t    if ((token < 0) || (token > yyName.Length)) return "[illegal]";
//t    string name;
//t    if ((name = yyName[token]) != null) return name;
//t    return "[unknown]";
//t  }

  /// <summary>
  /// computes list of expected tokens on error by tracing the tables.
  /// </summary>
  /// <param name="state"> for which to compute the list.</param>
  /// <returns>list of token names.</returns>
  protected string[] yyExpecting (int state) {
    int token, n, len = 0;
    bool[] ok = new bool[yyName.Length];

    if ((n = yySindex[state]) != 0)
      for (token = n < 0 ? -n : 0;
           (token < yyName.Length) && (n+token < yyTable.Length); ++ token)
        if (yyCheck[n+token] == token && !ok[token] && yyName[token] != null) {
          ++ len;
          ok[token] = true;
        }
    if ((n = yyRindex[state]) != 0)
      for (token = n < 0 ? -n : 0;
           (token < yyName.Length) && (n+token < yyTable.Length); ++ token)
        if (yyCheck[n+token] == token && !ok[token] && yyName[token] != null) {
          ++ len;
          ok[token] = true;
        }

    string [] result = new string[len];
    for (n = token = 0; n < len;  ++ token)
      if (ok[token]) result[n++] = yyName[token];
    return result;
  }

  /// <summary>
  /// the generated parser, with debugging messages.
  /// Maintains a state and a value stack, currently with fixed maximum size.
  /// </summary>
  /// <param name="yyLex"> scanner.</param>
  /// <param name="yyd"> debug message writer implementing yyDebug, or null.</param>
  /// <returns>result of the last reduction, if any.</returns>
  public Object yyparse (yyParser.yyInput yyLex, Object yyd)
				 {
//t    this.debug = (yydebug.yyDebug)yyd;
    return yyparse(yyLex);
  }

  /// <summary>
  /// initial size and increment of the state/value stack [default 256].
  /// This is not final so that it can be overwritten outside of invocations
  /// of yyparse().
  /// </summary>
  protected int yyMax;

  /// <summary>
  /// executed at the beginning of a reduce action.
  /// Used as $$ = yyDefault($1), prior to the user-specified action, if any.
  /// Can be overwritten to provide deep copy, etc.
  /// </summary>
  /// <param name="first"> value for $1, or null.</param>
  /// <returns>first.</returns>
  protected Object yyDefault (Object first) {
    return first;
  }

  /// <summary>
  /// the generated parser.
  /// Maintains a state and a value stack, currently with fixed maximum size.
  /// </summary>
  /// <param name="yyLex"> scanner</param>
  /// <returns>result of the last reduction, if any.</returns>
  public Object yyparse (yyParser.yyInput yyLex)
				{
    if (yyMax <= 0) yyMax = 256;			// initial size
    int yyState = 0;                                   // state stack ptr
    int [] yyStates = new int[yyMax];	                // state stack 
    Object yyVal = null;                               // value stack ptr
    Object [] yyVals = new Object[yyMax];	        // value stack
    int yyToken = -1;					// current input
    int yyErrorFlag = 0;				// #tks to shift

    int yyTop = 0;
    goto skip;
    yyLoop:
    yyTop++;
    skip:
    for (;; ++ yyTop) {
      if (yyTop >= yyStates.Length) {			// dynamically increase
        int[] i = new int[yyStates.Length+yyMax];
        System.Array.Copy(yyStates, i, 0);
        yyStates = i;
        Object[] o = new Object[yyVals.Length+yyMax];
        System.Array.Copy(yyVals, o, 0);
        yyVals = o;
      }
      yyStates[yyTop] = yyState;
      yyVals[yyTop] = yyVal;
//t      if (debug != null) debug.push(yyState, yyVal);

      yyDiscarded: for (;;) {	// discarding a token does not change stack
        int yyN;
        if ((yyN = yyDefRed[yyState]) == 0) {	// else [default] reduce (yyN)
          if (yyToken < 0) {
            yyToken = yyLex.advance() ? yyLex.token() : 0;
//t            if (debug != null)
//t              debug.lex(yyState, yyToken, yyname(yyToken), yyLex.value());
          }
          if ((yyN = yySindex[yyState]) != 0 && ((yyN += yyToken) >= 0)
              && (yyN < yyTable.Length) && (yyCheck[yyN] == yyToken)) {
//t            if (debug != null)
//t              debug.shift(yyState, yyTable[yyN], yyErrorFlag-1);
            yyState = yyTable[yyN];		// shift to yyN
            yyVal = yyLex.value();
            yyToken = -1;
            if (yyErrorFlag > 0) -- yyErrorFlag;
            goto yyLoop;
          }
          if ((yyN = yyRindex[yyState]) != 0 && (yyN += yyToken) >= 0
              && yyN < yyTable.Length && yyCheck[yyN] == yyToken)
            yyN = yyTable[yyN];			// reduce (yyN)
          else
            switch (yyErrorFlag) {
  
            case 0:
              yyerror(yyState,yyToken,yyLex.value(),yyExpecting(yyState));
//t              if (debug != null) debug.error("syntax error");
              goto case 1;
            case 1: case 2:
              yyErrorFlag = 3;
              do {
                if ((yyN = yySindex[yyStates[yyTop]]) != 0
                    && (yyN += Token.yyErrorCode) >= 0 && yyN < yyTable.Length
                    && yyCheck[yyN] == Token.yyErrorCode) {
//t                  if (debug != null)
//t                    debug.shift(yyStates[yyTop], yyTable[yyN], 3);
                  yyState = yyTable[yyN];
                  yyVal = yyLex.value();
                  goto yyLoop;
                }
//t                if (debug != null) debug.pop(yyStates[yyTop]);
              } while (-- yyTop >= 0);
//t              if (debug != null) debug.reject();
              throw new yyParser.yyException("irrecoverable syntax error");
  
            case 3:
              if (yyToken == 0) {
//t                if (debug != null) debug.reject();
                throw new yyParser.yyException("irrecoverable syntax error at end-of-file");
              }
//t              if (debug != null)
//t                debug.discard(yyState, yyToken, yyname(yyToken),
//t  							yyLex.value());
              yyToken = -1;
              goto yyDiscarded;		// leave stack alone
            }
        }
        int yyV = yyTop + 1-yyLen[yyN];
//t        if (debug != null)
//t          debug.reduce(yyState, yyStates[yyV-1], yyN, yyRule[yyN], yyLen[yyN]);
        yyVal = yyDefault(yyV > yyTop ? null : yyVals[yyV]);
        switch (yyN) {
case 1:
					// line 100 "Parser.jay"
  { generator.BeginProgram(); }
  break;
case 2:
					// line 100 "Parser.jay"
  { generator.EndProgram(); }
  break;
case 8:
					// line 109 "Parser.jay"
  { generator.AddStatement(yyVals[0+yyTop] as CodeStatement); }
  break;
case 9:
					// line 111 "Parser.jay"
  { arguments.Clear(); }
  break;
case 10:
					// line 111 "Parser.jay"
  { generator.BeginFunction(yyVals[-4+yyTop] as String, arguments); }
  break;
case 11:
					// line 111 "Parser.jay"
  { generator.EndFunction(); }
  break;
case 14:
					// line 116 "Parser.jay"
  { arguments.Add(yyVals[0+yyTop] as String); }
  break;
case 15:
					// line 117 "Parser.jay"
  { arguments.Add(yyVals[0+yyTop] as String); }
  break;
case 16:
					// line 119 "Parser.jay"
  { generator.BeginBlock(); }
  break;
case 20:
					// line 124 "Parser.jay"
  { generator.AddStatement(yyVals[0+yyTop] as CodeStatement); }
  break;
case 21:
					// line 125 "Parser.jay"
  { generator.AddStatement(yyVals[0+yyTop] as CodeStatement); }
  break;
case 22:
					// line 127 "Parser.jay"
  { yyVal = yyVals[0+yyTop]; }
  break;
case 23:
					// line 128 "Parser.jay"
  { yyVal = yyVals[0+yyTop]; }
  break;
case 24:
					// line 129 "Parser.jay"
  { yyVal = yyVals[0+yyTop]; }
  break;
case 25:
					// line 130 "Parser.jay"
  { yyVal = yyVals[0+yyTop]; }
  break;
case 26:
					// line 131 "Parser.jay"
  { yyVal = yyVals[0+yyTop]; }
  break;
case 27:
					// line 132 "Parser.jay"
  { yyVal = yyVals[0+yyTop]; }
  break;
case 28:
					// line 134 "Parser.jay"
  { yyVal = generator.DeclareVariable(yyVals[-2+yyTop] as String, yyVals[-1+yyTop] as CodeExpression); }
  break;
case 29:
					// line 136 "Parser.jay"
  { yyVal = yyVals[0+yyTop]; }
  break;
case 30:
					// line 137 "Parser.jay"
  { yyVal = null; }
  break;
case 31:
					// line 139 "Parser.jay"
  { yyVal = generator.AssignVariable(yyVals[-3+yyTop] as String, yyVals[-1+yyTop] as CodeExpression); }
  break;
case 32:
					// line 141 "Parser.jay"
  { yyVal = generator.EndBlock(); }
  break;
case 33:
					// line 141 "Parser.jay"
  { yyVal = generator.IfElse(yyVals[-5+yyTop] as CodeExpression, yyVals[-2+yyTop] as CodeStatementCollection, generator.EndBlock()); }
  break;
case 34:
					// line 142 "Parser.jay"
  { yyVal = generator.IfElse(yyVals[-2+yyTop] as CodeExpression, generator.EndBlock(), null); }
  break;
case 35:
					// line 144 "Parser.jay"
  { generator.BeginListExpr(); }
  break;
case 36:
					// line 144 "Parser.jay"
  { yyVal = generator.FunctionCall(yyVals[-4+yyTop] as String, generator.EndListExpr()); }
  break;
case 37:
					// line 146 "Parser.jay"
  { yyVal = generator.Statement(yyVals[-1+yyTop] as CodeExpression); }
  break;
case 38:
					// line 148 "Parser.jay"
  { yyVal = generator.While(yyVals[-2+yyTop] as CodeExpression, generator.EndBlock()); }
  break;
case 39:
					// line 150 "Parser.jay"
  { yyVal = generator.Return(yyVals[-1+yyTop] as CodeExpression); }
  break;
case 40:
					// line 151 "Parser.jay"
  { yyVal = generator.Return(null); }
  break;
case 42:
					// line 154 "Parser.jay"
  { generator.BeginBlock(); generator.AddStatement(yyVals[0+yyTop] as CodeStatement); }
  break;
case 43:
					// line 156 "Parser.jay"
  { yyVal = generator.BinaryOperator(yyVals[-2+yyTop] as CodeExpression, CodeBinaryOperatorType.ValueEquality, yyVals[0+yyTop] as CodeExpression); }
  break;
case 44:
					// line 157 "Parser.jay"
  { yyVal = generator.BinaryOperator(yyVals[-2+yyTop] as CodeExpression, CodeBinaryOperatorType.IdentityInequality, yyVals[0+yyTop] as CodeExpression); }
  break;
case 45:
					// line 158 "Parser.jay"
  { yyVal = generator.BinaryOperator(yyVals[-2+yyTop] as CodeExpression, CodeBinaryOperatorType.GreaterThan, yyVals[0+yyTop] as CodeExpression); }
  break;
case 46:
					// line 159 "Parser.jay"
  { yyVal = generator.BinaryOperator(yyVals[-2+yyTop] as CodeExpression, CodeBinaryOperatorType.LessThan, yyVals[0+yyTop] as CodeExpression); }
  break;
case 47:
					// line 160 "Parser.jay"
  { yyVal = generator.BinaryOperator(yyVals[-2+yyTop] as CodeExpression, CodeBinaryOperatorType.GreaterThanOrEqual, yyVals[0+yyTop] as CodeExpression); }
  break;
case 48:
					// line 161 "Parser.jay"
  { yyVal = generator.BinaryOperator(yyVals[-2+yyTop] as CodeExpression, CodeBinaryOperatorType.LessThanOrEqual, yyVals[0+yyTop] as CodeExpression); }
  break;
case 49:
					// line 163 "Parser.jay"
  { yyVal = generator.BinaryOperator(yyVals[-2+yyTop] as CodeExpression, CodeBinaryOperatorType.Add, yyVals[0+yyTop] as CodeExpression); }
  break;
case 50:
					// line 164 "Parser.jay"
  { yyVal = generator.BinaryOperator(yyVals[-2+yyTop] as CodeExpression, CodeBinaryOperatorType.Multiply, yyVals[0+yyTop] as CodeExpression); }
  break;
case 51:
					// line 165 "Parser.jay"
  { yyVal = generator.BinaryOperator(yyVals[-2+yyTop] as CodeExpression, CodeBinaryOperatorType.Subtract, yyVals[0+yyTop] as CodeExpression); }
  break;
case 52:
					// line 166 "Parser.jay"
  { yyVal = generator.BinaryOperator(yyVals[-2+yyTop] as CodeExpression, CodeBinaryOperatorType.Divide, yyVals[0+yyTop] as CodeExpression); }
  break;
case 53:
					// line 167 "Parser.jay"
  { yyVal = yyVals[0+yyTop]; }
  break;
case 54:
					// line 168 "Parser.jay"
  { yyVal = yyVals[0+yyTop]; }
  break;
case 55:
					// line 170 "Parser.jay"
  { yyVal = generator.NumberConstant((int)yyVals[0+yyTop]); }
  break;
case 56:
					// line 171 "Parser.jay"
  { yyVal = generator.StringConstant(yyVals[0+yyTop] as String); }
  break;
case 57:
					// line 172 "Parser.jay"
  { yyVal = generator.Variable(yyVals[0+yyTop] as String); }
  break;
case 60:
					// line 177 "Parser.jay"
  { generator.AddExpression(yyVals[0+yyTop] as CodeExpression); }
  break;
case 61:
					// line 178 "Parser.jay"
  { generator.AddExpression(yyVals[0+yyTop] as CodeExpression); }
  break;
					// line 523 "-"
        }
        yyTop -= yyLen[yyN];
        yyState = yyStates[yyTop];
        int yyM = yyLhs[yyN];
        if (yyState == 0 && yyM == 0) {
//t          if (debug != null) debug.shift(0, yyFinal);
          yyState = yyFinal;
          if (yyToken < 0) {
            yyToken = yyLex.advance() ? yyLex.token() : 0;
//t            if (debug != null)
//t               debug.lex(yyState, yyToken,yyname(yyToken), yyLex.value());
          }
          if (yyToken == 0) {
//t            if (debug != null) debug.accept(yyVal);
            return yyVal;
          }
          goto yyLoop;
        }
        if (((yyN = yyGindex[yyM]) != 0) && ((yyN += yyState) >= 0)
            && (yyN < yyTable.Length) && (yyCheck[yyN] == yyState))
          yyState = yyTable[yyN];
        else
          yyState = yyDgoto[yyM];
//t        if (debug != null) debug.shift(yyStates[yyTop], yyState);
	 goto yyLoop;
      }
    }
  }

   static  short [] yyLhs  = {              -1,
    2,    0,    1,    1,    3,    3,    4,    4,    7,   10,
    5,    8,    8,   11,   11,   13,    9,   12,   12,   14,
   14,    6,    6,    6,    6,    6,    6,   15,   21,   21,
   16,   25,   17,   17,   28,   26,   19,   18,   20,   20,
   24,   24,   23,   23,   23,   23,   23,   23,   22,   22,
   22,   22,   22,   22,   29,   29,   29,   27,   27,   30,
   30,
  };
   static  short [] yyLen = {           2,
    0,    2,    1,    0,    2,    1,    1,    1,    0,    0,
    8,    1,    0,    3,    1,    0,    4,    1,    0,    2,
    1,    1,    1,    1,    1,    1,    1,    4,    2,    0,
    4,    0,    8,    5,    0,    5,    2,    5,    3,    2,
    1,    1,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    1,    1,    1,    1,    1,    1,    0,    3,
    1,
  };
   static  short [] yyDefRed = {            1,
    0,    0,    0,    0,    0,    0,    0,    0,    2,    0,
    6,    7,    8,   22,   23,   24,   25,   26,   27,    0,
    0,   35,    0,    9,    0,    0,   40,   55,   56,    0,
    0,   53,   54,    5,   37,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   39,   31,    0,
    0,    0,    0,   28,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   50,   52,   36,    0,   15,
    0,    0,    0,    0,    0,    0,    0,    0,   16,   42,
   41,    0,   38,    0,   10,    0,    0,    0,    0,   14,
   21,    0,    0,    0,   11,   17,   20,   33,
  };
  protected static  short [] yyDgoto  = {             1,
    9,    2,   10,   11,   12,   80,   40,   71,   81,   89,
   72,   92,   87,   93,   14,   15,   16,   17,   18,   19,
   39,   41,   42,   82,   88,   32,   51,   37,   33,   52,
  };
  protected static  short [] yySindex = {            0,
    0, -155, -252, -265, -259, -242, -238, -138,    0, -155,
    0,    0,    0,    0,    0,    0,    0,    0,    0, -240,
 -239,    0, -205,    0, -239, -239,    0,    0,    0, -209,
 -215,    0,    0,    0,    0, -211, -239, -239, -216, -200,
 -147, -192, -191, -239, -239, -239, -239,    0,    0, -118,
 -186, -184, -118,    0, -180, -239, -239, -239, -239, -239,
 -239, -195, -195, -254, -254,    0,    0,    0, -239,    0,
 -179, -175, -118, -118, -118, -118, -118, -118,    0,    0,
    0,    0,    0, -118,    0, -172, -148, -174, -163,    0,
    0, -157, -148, -195,    0,    0,    0,    0,
  };
  protected static  short [] yyRindex = {            0,
    0,  125,    0,    0,    0,    0,    0,    0,    0,  130,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, -141,    0,    0,    0,    0,    0,    0, -193,
    0,    0,    0,    0,    0,    0, -126,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, -262,
    0, -125, -128,    0, -123,    0,    0,    0,    0,    0,
    0,    0,    0, -244, -164,    0,    0,    0,    0,    0,
    0, -122, -121, -120, -119, -117, -116, -115,    0,    0,
    0,    1,    0, -245,    0,    0, -114,    0,    0,    0,
    0,    0, -113,    0,    0,    0,    0,    0,
  };
  protected static  short [] yyGindex = {            0,
    0,    0,    0,  141,    0,    2,    0,    0,   66,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   -6,  133,  -60,    0,   -2,    0,    0,    0,    0,
  };
  protected static  short [] yyTable = {            20,
   34,   31,   83,   13,   46,   47,   61,   20,   21,   61,
   23,   13,   49,   49,   36,   22,   24,   49,   49,   49,
   49,   49,   49,   60,   49,   25,   60,   49,   49,   26,
   50,   53,   35,   98,   28,   29,   30,   64,   65,   66,
   67,   44,   45,   46,   47,   44,   45,   46,   47,   73,
   74,   75,   76,   77,   78,   38,   54,   48,   22,   20,
   20,   49,   84,   57,   57,   57,   57,   55,   57,   57,
   57,   57,   57,   57,   79,   57,   62,   63,   57,   57,
    3,    4,   68,    6,   20,    7,    8,   69,   91,   85,
   20,   20,   51,   51,   97,   70,   86,   51,   51,   51,
   51,   51,   51,   90,   51,   94,   79,   51,   51,   44,
   45,   46,   47,   96,   56,   57,   58,   59,   60,   61,
    3,    4,    5,    6,    4,    7,    8,    3,    4,    3,
    6,   30,    7,    8,   27,   28,   29,   30,   44,   45,
   46,   47,   59,   58,   29,   13,   12,   43,   44,   45,
   34,   46,   47,   48,   95,    0,   19,   18,   43,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   34,    0,    0,    0,    0,   34,   34,   34,   34,
   32,   34,   34,
  };
  protected static  short [] yyCheck = {             2,
    0,    8,   63,    2,  259,  260,  269,   10,  261,  272,
  276,   10,  257,  258,   21,  268,  276,  262,  263,  264,
  265,  266,  267,  269,  269,  268,  272,  272,  273,  268,
   37,   38,  273,   94,  274,  275,  276,   44,   45,   46,
   47,  257,  258,  259,  260,  257,  258,  259,  260,   56,
   57,   58,   59,   60,   61,  261,  273,  273,  268,   62,
   63,  273,   69,  257,  258,  259,  260,  268,  262,  263,
  264,  265,  266,  267,  270,  269,  269,  269,  272,  273,
  276,  277,  269,  279,   87,  281,  282,  272,   87,  269,
   93,   94,  257,  258,   93,  276,  272,  262,  263,  264,
  265,  266,  267,  276,  269,  280,  270,  272,  273,  257,
  258,  259,  260,  271,  262,  263,  264,  265,  266,  267,
  276,  277,  278,  279,    0,  281,  282,  276,  277,    0,
  279,  273,  281,  282,  273,  274,  275,  276,  257,  258,
  259,  260,  269,  269,  273,  269,  269,  269,  269,  269,
   10,  269,  269,  269,   89,   -1,  271,  271,   26,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  271,   -1,   -1,   -1,   -1,  276,  277,  278,  279,
  280,  281,  282,
  };

					// line 184 "Parser.jay"


    /// <summary>
	/// Current tokenizer
	/// </summary>
	private Lexer lexer;
		
	
	/// <summary>
	/// Constructor with a file.
	/// </summary>	
	public Parser(string name, string source)
	{
		lexer = new Lexer(name, source);
		Init();       
	}
		
	
	/// <summary>
	/// Constructor with a source.
	/// </summary>	
	public Parser(string source)
	{
		lexer = new Lexer(" ", source);
		Init();
	}
	
	/// <summary>
	/// Init parser fields.
	/// </summary>
	private void Init()
	{
		report = new Report();
		generator = new Generator("MJSProgram", report, lexer.Location);
        arguments = new List<string>();	    
    }
	
	/// <summary>
	/// Parse the input.
	/// </summary>
	/// <returns>a CodeDOM tree for the resulting C# code</returns>
	public override bool Parse()
	{
		// Do parsing, to debug: set yacc_verbose_flag and replace "//t" comment by "" in C# parser file
		try {
			if (yacc_verbose_flag)
				yyparse(lexer, new yydebug.yyDebugSimple ());
			else
				yyparse(lexer);
		} 
		catch(yyParser.yyException)
		{
		}	    
		catch (Exception e)
		{	
			Console.Error.WriteLine ("Fatal error [input pos.: {0},{1}]", lexer.Location.Row, lexer.Location.Col);
			Console.Error.WriteLine (e.ToString());
			return false;
		}
		
		if ( report.Errors.Count != 0 )
			return false;
		else
			return true;
	}
}
					// line 747 "-"
namespace yydebug {
        using System;
	 public interface yyDebug {
        /// <summary>
        /// Push a state an its value.
        /// </summary>
        /// <param name="state">state to push</param>
        /// <param name="value">state value</param>
		 void push (int state, Object value);

        /// <summary>
        /// Get a token.
        /// </summary>
        /// <param name="state">state</param>
        /// <param name="token">token</param>
        /// <param name="name">name</param>
        /// <param name="value">state value</param>
		 void lex (int state, int token, string name, Object value);
		 
        /// <summary>
        /// Advance from a state.
        /// </summary>
        /// <param name="from">start state</param>
        /// <param name="to">end state</param>
        /// <param name="errorFlag">error flag</param>
		 void shift (int from, int to, int errorFlag);
		 
        /// <summary>
        /// Pop a state.
        /// </summary>
        /// <param name="state">state</param>
		 void pop (int state);
		 
        /// <summary>
        /// Discard state.
        /// </summary>
        /// <param name="state">state</param>
        /// <param name="token">token</param>
        /// <param name="name">name</param>
        /// <param name="value">state value</param>
		 void discard (int state, int token, string name, Object value);
		 
        /// <summary>
        /// Reduce state.
        /// </summary>
        /// <param name="from">from</param>
        /// <param name="to">to</param>
        /// <param name="rule">rule</param>
        /// <param name="text">text</param>
        /// <param name="len">len</param>
		 void reduce (int from, int to, int rule, string text, int len);
		 
        /// <summary>
        /// Advance from a state.
        /// </summary>
        /// <param name="from">start state</param>
        /// <param name="to">end state</param>
		 void shift (int from, int to);
		 
        /// <summary>
        /// Accept state.
        /// </summary>
        /// <param name="value">value</param>
		 void accept (Object value);
		
        /// <summary>
        /// Error.
        /// </summary>
        /// <param name="message">message</param> 
		 void error (string message);
		 
        /// <summary>
        /// Reject state.
        /// </summary>
		 void reject ();
	 }
	
    /// <summary>
    /// Single debug class.
    /// </summary> 
	 class yyDebugSimple : yyDebug {
        /// <summary>
        /// Print string on a new line.
        /// </summary>
        /// <param name="s">string to print</param>
		 void println (string s){
			 Console.Error.WriteLine(s);
		 }
		 
        /// <summary>
        /// Push a state an its value.
        /// </summary>
        /// <param name="state">state to push</param>
        /// <param name="value">state value</param>
		 public void push (int state, Object value) {
			 println("push\tstate "+state+"\tvalue "+value);
		 }

        /// <summary>
        /// Get a token.
        /// </summary>
        /// <param name="state">state</param>
        /// <param name="token">token</param>
        /// <param name="name">name</param>
        /// <param name="value">state value</param>	 
		 public void lex (int state, int token, string name, Object value) {
			 println("lex\tstate "+state+"\treading "+name+"\tvalue "+value);
		 }
		 
        /// <summary>
        /// Advance from a state.
        /// </summary>
        /// <param name="from">start state</param>
        /// <param name="to">end state</param>
        /// <param name="errorFlag">error flag</param>
		 public void shift (int from, int to, int errorFlag) {
			 switch (errorFlag) {
			 default:				// normally
				 println("shift\tfrom state "+from+" to "+to);
				 break;
			 case 0: case 1: case 2:		// in error recovery
				 println("shift\tfrom state "+from+" to "+to
					     +"\t"+errorFlag+" left to recover");
				 break;
			 case 3:				// normally
				 println("shift\tfrom state "+from+" to "+to+"\ton error");
				 break;
			 }
		 }
		 
        /// <summary>
        /// Pop a state.
        /// </summary>
        /// <param name="state">state</param>
		 public void pop (int state) {
			 println("pop\tstate "+state+"\ton error");
		 }
		 
        /// <summary>
        /// Discard state.
        /// </summary>
        /// <param name="state">state</param>
        /// <param name="token">token</param>
        /// <param name="name">name</param>
        /// <param name="value">state value</param>
		 public void discard (int state, int token, string name, Object value) {
			 println("discard\tstate "+state+"\ttoken "+name+"\tvalue "+value);
		 }
		 
        /// <summary>
        /// Reduce state.
        /// </summary>
        /// <param name="from">from</param>
        /// <param name="to">to</param>
        /// <param name="rule">rule</param>
        /// <param name="text">text</param>
        /// <param name="len">len</param>
		 public void reduce (int from, int to, int rule, string text, int len) {
			 println("reduce\tstate "+from+"\tuncover "+to
				     +"\trule ("+rule+") "+text);
		 }
		 
        /// <summary>
        /// Shift state.
        /// </summary>
        /// <param name="from">start state</param>
        /// <param name="to">end state</param>
		 public void shift (int from, int to) {
			 println("goto\tfrom state "+from+" to "+to);
		 }
		 
        /// <summary>
        /// Accept state.
        /// </summary>
        /// <param name="value">value</param>
		 public void accept (Object value) {
			 println("accept\tvalue "+value);
		 }
		
        /// <summary>
        /// Error.
        /// </summary>
        /// <param name="message">message</param> 
		 public void error (string message) {
			 println("error\t"+message);
		 }
		 
        /// <summary>
        /// Reject state.
        /// </summary>
		 public void reject () {
			 println("reject");
		 }
		 
	 }
}
 /// <summary>
 /// Token constants.
 /// </summary>
 public class Token {
  public const int EOF = 0;
  public const int PLUS = 257;
  public const int MINUS = 258;
  public const int MULT = 259;
  public const int DIV = 260;
  public const int EQ = 261;
  public const int EQEQ = 262;
  public const int NE = 263;
  public const int GT = 264;
  public const int LS = 265;
  public const int GTEQ = 266;
  public const int LSEQ = 267;
  public const int LPAR = 268;
  public const int RPAR = 269;
  public const int LBRA = 270;
  public const int RBRA = 271;
  public const int CM = 272;
  public const int SC = 273;
  public const int NUMBER = 274;
  public const int STRING = 275;
  public const int IDENT = 276;
  public const int VAR = 277;
  public const int FUNCTION = 278;
  public const int IF = 279;
  public const int ELSE = 280;
  public const int WHILE = 281;
  public const int RETURN = 282;
  public const int ERROR = 283;
  public const int yyErrorCode = 256;
 }
 namespace yyParser {
  using System;
 /// <summary>
 /// Thrown for irrecoverable syntax errors and stack overflow.
 /// </summary>
  public class yyException : System.Exception {
    /// <summary>
    /// Exception.
    /// </summary>
    /// <param name="message">message</param>
    public yyException (string message) : base (message) {
    }
  }

 /// <summary>
 /// Must be implemented by a scanner object to supply input to the parser.
 /// </summary>
  public interface yyInput {
    /// <summary>
    /// Move on to next token.
    /// </summary>
	 /// <returns>false if positioned beyond tokens</returns>
    bool advance (); // throws java.io.IOException;

    /// <summary>
    /// Classifies current token. Should not be called if advance() returned false.
    /// </summary>
	 /// <returns>current %token or single character</returns>
    int token ();

    /// <summary>
    /// Associated with current token. Should not be called if advance() returned false.
    /// </summary>
	 /// <returns>value for token()</returns>
    Object value ();
  }
 }
} // close outermost namespace, that MUST HAVE BEEN opened in the prolog
//#if net_2_0
//#pragma warning restore 1591, 162
//#endif
